from Sink import Sink, SinkInfo
from pyjamas.ui.TabPanel import TabPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.TextArea import TextArea
from pyjamas.ui.HTML import HTML
from SfaData import OpenCirrusData
from RequestPanel import RequestPanel
from InstancePanel import InstancePanel
from SubmitPanel import SubmitPanel
from HelpPanel import OCHelpPanel

class OCTabs(TabPanel):
    def __init__(self, data):
        TabPanel.__init__(self)

        self.data = data
        self.data.refreshRSpec()

        requesttab = RequestPanel(self.data)
        instancetab = InstancePanel(self.data)
        submittab = SubmitPanel(self.data)
        helptab = OCHelpPanel()

        self.add(requesttab, "Request")
        self.add(instancetab, "Instances")
        self.add(submittab, "Submit")
        self.add(HTML("force tabs to right"), None)
        self.add(helptab, "Help")
        self.selectTab(0)

    def onTabSelected(self, sender, index):
        tab = self.getWidget(index)
        tab.refresh()
        TabPanel.onTabSelected(self, sender, index)

class OpenCirrus(Sink):
    def __init__(self):

        Sink.__init__(self)

        self.tabs = OCTabs(OpenCirrusData())

        self.tabs.setWidth("100%")
        self.tabs.setHeight("100%")
        self.initWidget(self.tabs)

    def onShow(self):
        pass


def init():
    return SinkInfo("OpenCirrus", "Specify OpenCirrus Resources", OpenCirrus)
